$(document).ready(function() {
  var url = 'http://localhost:5000/classroom/buildings/';
  $.ajax({
    url: url,
    type: 'GET',
    success: function(response) {
      var bldgs = response.buildings;
      // populate for update
      var htmlCode = "<select id='bcode1' onchange='populateRooms1()'>"+
                     "<option id='None'>Select a building</option>";
      for (var i=0; i<bldgs.length; i++)
        htmlCode += "<option value='"+bldgs[i].bldg+"'>"+bldgs[i].bname+"</option>";
      htmlCode += "</select>";
      $("#building_select1").html(htmlCode);
      // populate for delete
      var htmlCode = "<select id='bcode2' onchange='populateRooms2()'>"+
                     "<option id='None'>Select a building</option>";
      for (var i=0; i<bldgs.length; i++)
        htmlCode += "<option value='"+bldgs[i].bldg+"'>"+bldgs[i].bname+"</option>";
      htmlCode += "</select>";
      $("#building_select2").html(htmlCode);
      // populate for insert
      var htmlCode = "<select id='bcode3'>"+
                     "<option id='None'>Select a building</option>";
      for (var i=0; i<bldgs.length; i++)
        htmlCode += "<option value='"+bldgs[i].bldg+"'>"+bldgs[i].bname+"</option>";
      htmlCode += "</select>";
      $("#building_select3").html(htmlCode);
    },
    error: function(error) {
      alert("ERROR");
      console.log(error);
    }
  });
  var url = 'http://localhost:5000/classroom/media/';
  $.ajax({
    url: url,
    type: 'GET',
    success: function(response) {
      var media = response.media;
      var htmlCode = "";
      for (var i=0; i<media.length; i++)
        htmlCode += "<label><input type='checkbox' name='media[]' value='"+
                    media[i].mcode+"' />"+media[i].mdescription+"</label><br />";
      $("#media_checkboxes").html(htmlCode);
    },
    error: function(error) {
      alert("ERROR");
      console.log(error);
    }
  });
});

function populateRooms1() {
  var url = 'http://localhost:5000/classroom/rooms/' + $("#bcode1").val() + '/';
  $.ajax({
    url: url,
    type: 'GET',
    success: function(response) {
      var rooms = response.rooms;
      var htmlCode = "<select id='rnumber1'>"+
                     "<option id='None'>Select a room</option>";
      for (var i=0; i<rooms.length; i++)
        htmlCode += "<option value='"+rooms[i].rnumber+"'>"+rooms[i].rnumber+"</option>";
      htmlCode += "</select>";
      $("#room_select1").html(htmlCode);
    },
    error: function(error) {
      alert("ERROR");
      console.log(error);
    }
  });
};

function populateRooms2() {
  var url = 'http://localhost:5000/classroom/rooms/' + $("#bcode2").val() + '/';
  $.ajax({
    url: url,
    type: 'GET',
    success: function(response) {
      var rooms = response.rooms;
      var htmlCode = "<select id='rnumber2'>"+
                     "<option id='None'>Select a room</option>";
      for (var i=0; i<rooms.length; i++)
        htmlCode += "<option value='"+rooms[i].rnumber+"'>"+rooms[i].rnumber+"</option>";
      htmlCode += "</select>";
      $("#room_select2").html(htmlCode);
    },
    error: function(error) {
      alert("ERROR");
      console.log(error);
    }
  });
};

function validateCap(cap) { 
  return /^([1-9]|[1-9]\d+)$/.test(cap)
}

function updateRoomCap() {
  if (!validateCap($("#newcap").val())) {
    alert("Invalid Capacity");
    return;
  }
  var url = 'http://localhost:5000/classroom/' + $("#bcode1").val() + '/' + $("#rnumber1").val() + '/';
  var newRoom = { "newcap": $("#newcap").val() }
  $.ajax({
    url: url,
    type: 'PUT',
    data: JSON.stringify(newRoom),
    contentType: "application/json; charset=utf-8",
    dataType: "json",
    success: function(response) {
      if (response.ok) {
        var htmlCode = "<p><b>Capacity of room "+response.bldg+
                       " "+response.rnumber+" "+
                       "has been updated to "+response.cap;
        $("#update_result").html(htmlCode);
      }
      else {
        var htmlCode = "<p><b>Capacity of room "+response.bldg+
                       " "+response.rnumber+" "+
                       "could not be updated";
        $("#update_result").html(htmlCode);
      }
    },
    error: function(error) {
      alert("ERROR");
      console.log(error);
    }
  });
}

function deleteRoom() {
  var url = "http://localhost:5000/classroom/rooms/" + $("#bcode2").val() + "/" + $("#rnumber2").val() + "/";
  //console.log(url);
  $.ajax({
    url: url,
    //data: JSON.stringify(room),
    contentType: "application/json; charset=utf-8",
    dataType: "json",
    type: 'DELETE',
    success: function(response) {
      if (response.ok) {
        var htmlCode = "<p><b>Room "+response.bldg+ " "+response.rnumber+" "+ "has been deleted";
        $("#delete_result").html(htmlCode);
      }
      else {
        var htmlCode = "<p><b>Room "+response.bldg+ " "+response.rnumber+" "+ "could not be deleted";
        $("#delete_result").html(htmlCode);
      }
    },
    error: function(error) {
      alert("ERROR");
      console.log(error);
    }
  });
}

function insertRoom() {
  if (!validateCap($("#insert_cap").val())) {
    alert("Invalid Capacity");
    return;
  }
  if ($("#insert_rnumber").val().trim() == "") {
    alert("Room number required");
    return;
  }
  var newRoom = {"cap": $("#insert_cap").val(),
                 "layout": $("#insert_layout").val(),
                 "rtype": $("#insert_rtype").val(),
                 "dept": $("#insert_dept").val()
                }
  var media = [];
  $("input[name='media[]']:checked").each(function () {
    media.push($(this).val());
  });
  newRoom["media"] = media;
  var url = 'http://localhost:5000/classroom/rooms/' + $("#bcode3").val() + '/' + $("#insert_rnumber").val() + '/';
  $.ajax({
    url: url,
    type: 'POST',
    data: JSON.stringify(newRoom),
    contentType: "application/json; charset=utf-8",
    dataType: "json",
    success: function(response) {
      if (response.ok) {
        var htmlCode = "<p><b>Room "+response.bldg+ " "+response.rnumber+" "+ "has been inserted";
        $("#insert_result").html(htmlCode);
      }
      else {
        var htmlCode = "<p><b>Room "+response.bldg+ " "+response.rnumber+" "+ "could not be inserted";
        $("#insert_result").html(htmlCode);
      }
    },
    error: function(error) {
      alert("ERROR");
      console.log(error);
    }
  });
}
