$(document).ready(function() {
  var url = 'http://localhost:5000/classroom/buildings/';
  $.ajax({
    url: url,
    type: 'GET',
    success: function(response) {
      var bldgs = response.buildings;
      var htmlCode = "<select id='bcode' onchange='populateRooms()'>"+
                     "<option id='None'>Select a building</option>";
      for (var i=0; i<bldgs.length; i++)
        htmlCode += "<option value='"+bldgs[i].bldg+"'>"+bldgs[i].bname+"</option>";
      htmlCode += "</select>";
      $("#building_select").html(htmlCode);
    },
    error: function(error) {
      alert("ERROR");
      console.log(error);
    }
  });
});

function populateRooms() {
  var url = 'http://localhost:5000/classroom/rooms/' + $("#bcode").val() + '/';
  $.ajax({
    url: url,
    type: 'GET',
    success: function(response) {
      var rooms = response.rooms;
      var htmlCode = "<select id='rnumber' onchange='getRoomDetails()' >"+
                     "<option id='None'>Select a room</option>";
      for (var i=0; i<rooms.length; i++)
        htmlCode += "<option value='"+rooms[i].rnumber+"'>"+rooms[i].rnumber+"</option>";
      htmlCode += "</select>";
      $("#room_select").html(htmlCode);
    },
    error: function(error) {
      alert("ERROR");
      console.log(error);
    }
  });
};

function getRoomDetails() {
  var url1 = 'http://localhost:5000/classroom/rooms/' +
             $("#bcode").val() + '/' + $("#rnumber").val() + '/';
  var url2 = 'http://localhost:5000/classroom/rooms/' +
             $("#bcode").val() + '/' + $("#rnumber").val() + '/media/';
  //console.log(url);
  $.ajax({
    url: url1,
    type: 'GET',
    success: function(response) {
      var htmlCode = "<table>";
      htmlCode += "<tr><td><b>BUILDING:</b></td><td>"+response.building+"</td></tr>";
      htmlCode += "<tr><td><b>ROOM:</b></td><td>"+response.rnumber+"</td></tr>";
      htmlCode += "<tr><td><b>CAPACITY:</b></td><td>"+response.cap+"</td></tr>";
      htmlCode += "<tr><td><b>LAYOUT:</b></td><td>"+response.layout+"</td></tr>";
      if (response.rtype == 'P')
        htmlCode += "<tr><td><b>TYPE:</b></td><td>"+
                    response.rtype+" ("+response.dept+")</td></tr>";
      else
        htmlCode += "<tr><td><b>TYPE:</b></td><td>"+response.type+"</td></tr>";
      htmlCode += "<tr><td><b>DEPT:</b></td><td>"+response.dept+"</td></tr>";
      $.ajax({
        url: url2,
        type: 'GET',
        success: function(response) {
          htmlCode += "<tr><td valign='top'><b>MEDIA:</b></td><td>";
          var media = response.media;
          for (var i=0; i<media.length; i++)
            htmlCode += media[i].mdescription+" ("+media[i].mcode+")<br />";
          htmlCode += "</td></tr></table>";
          $("#room_details").html(htmlCode);
        },
        error: function(error) {
          alert("ERROR");
          console.log(error);
        }
      });
    },
    error: function(error) {
      alert("ERROR");
      console.log(error);
    }
  });
}
